<template>
  <li class="accordion-item">
    <div
      class="accordion-item__header"
      :class="{ 'accordion-item__header--active': visible }"
      @click="open"
    >
      <!-- header slot -->
      <slot name="header"></slot>
    </div>

    <transition
      name="accordion"
      @enter="start"
      @before-leave="start"
      @after-leave="end"
    >
      <div
        class="accordion-item__content"
        :class="{ 'accordion-item__content--hidden': !visible }"
        v-show="visible"
      >
        <!-- content slot -->
        <slot name="content"></slot>
      </div>
    </transition>
  </li>
</template>

<script>
export default {
  name: 'AccordionItem',
  inject: ['accordion'],
  data() {
    return {
      index: null
    }
  },
  computed: {
    visible() {
      return this.index == this.accordion.active
    }
  },
  methods: {
    open() {
      if (this.visible) {
        this.accordion.active = null
      } else {
        this.accordion.active = this.index
      }
    },
    start(el) {
      el.style.height = el.scrollHeight + 'px'
    },
    end(el) {
      el.style.height = ''
    }
  },
  created() {
    this.index = this.accordion.count++
  }
}
</script>
